Subject: Re: [patch net-next v2 11/11] devlink: extend health reporter dump selector by port index

From: Jakub Kicinski <[email-masked]>
Date: Tue, 1 Aug 2023 08:56:44 -0700

On Tue, 1 Aug 2023 08:49:45 +0200 Jiri Pirko wrote:
> >for_each_obj() {
> >	if (obj_dump_filtered(obj, dump_info))  // < run filter
> >		continue;                       // < skip object
> >
> >	dump_one(obj)  
> 
> I don't see how this would help. For example, passing PORT_INDEX, I know
> exactly what object to reach, according to this PORT_INDEX. Why to
> iterate over all of them and try the filter? Does not make sense to me.
> 
> Maybe we are each understanding this feature differently. This is about
> passing keys which index the objects. It is always devlink handle,
> sometimes port index and I see another example in shared buffer index.
> That's about it. Basically user passes partial tuple of indexes.
> Example:
> devlink port show
> the key is: bus_name/dev_name/port_index
> user passes bus_name/dev_name, this is the selector, a partial key.
> 
> The sophisticated filtering is not a focus of this patchset. User can do
> it putting bpf filter on the netlink socket.

Okay, I was trying to be helpful, I don't want to argue for
a particular implementation. IMO what's posted is too ugly
to be merged, please restructure it.